
_Delay_6ms:

;One-Wire LCD.c,26 :: 		void Delay_6ms() {
;One-Wire LCD.c,27 :: 		Delay_ms(6);
	MOV	#4000, W7
L_Delay_6ms0:
	DEC	W7
	BRA NZ	L_Delay_6ms0
;One-Wire LCD.c,28 :: 		}
L_end_Delay_6ms:
	RETURN
; end of _Delay_6ms

_Delay_15us:

;One-Wire LCD.c,30 :: 		void Delay_15us() {
;One-Wire LCD.c,31 :: 		Delay_us(10);
	MOV	#6, W7
L_Delay_15us2:
	DEC	W7
	BRA NZ	L_Delay_15us2
	NOP
	NOP
;One-Wire LCD.c,32 :: 		}
L_end_Delay_15us:
	RETURN
; end of _Delay_15us

_Send_Byte:

;One-Wire LCD.c,34 :: 		void Send_Byte(char rs, char out_char) {
;One-Wire LCD.c,35 :: 		char i = 0, mask = 0x80;
; mask start address is: 6 (W3)
	MOV.B	#128, W3
;One-Wire LCD.c,37 :: 		out_char.F1 = rs;
	BSET.B	W11, #1
	BTSS	W10, #0
	BCLR.B	W11, #1
;One-Wire LCD.c,39 :: 		for(i = 0; i < 7; i++) {    // send all 7 bits
; i start address is: 4 (W2)
	CLR	W2
; mask end address is: 6 (W3)
; i end address is: 4 (W2)
L_Send_Byte4:
; i start address is: 4 (W2)
; mask start address is: 6 (W3)
	CP.B	W2, #7
	BRA LTU	L__Send_Byte44
	GOTO	L_Send_Byte5
L__Send_Byte44:
;One-Wire LCD.c,40 :: 		if(out_char & mask) {   // if HI bit, make 1uS low pulse
	ZE	W11, W1
	ZE	W3, W0
	AND	W1, W0, W0
	BRA NZ	L__Send_Byte45
	GOTO	L_Send_Byte7
L__Send_Byte45:
;One-Wire LCD.c,41 :: 		One_Wire = 0;      // make LO pulse
	BCLR	LATB0_bit, BitPos(LATB0_bit+0)
;One-Wire LCD.c,42 :: 		One_Wire = 1;      // end LO pulse
	BSET	LATB0_bit, BitPos(LATB0_bit+0)
;One-Wire LCD.c,43 :: 		Delay_15uS();      // safe 15uS pulse recovery
	CALL	_Delay_15us
;One-Wire LCD.c,44 :: 		}
	GOTO	L_Send_Byte8
L_Send_Byte7:
;One-Wire LCD.c,46 :: 		One_Wire = 0;
	BCLR	LATB0_bit, BitPos(LATB0_bit+0)
;One-Wire LCD.c,47 :: 		Delay_15uS();      // 15uS LO pulse
	CALL	_Delay_15us
;One-Wire LCD.c,48 :: 		One_Wire = 1;
	BSET	LATB0_bit, BitPos(LATB0_bit+0)
;One-Wire LCD.c,49 :: 		Delay_15uS();      // 30uS recovery
	CALL	_Delay_15us
;One-Wire LCD.c,50 :: 		Delay_15uS();
	CALL	_Delay_15us
;One-Wire LCD.c,51 :: 		}
L_Send_Byte8:
;One-Wire LCD.c,53 :: 		mask >>= 1;             // get the next bit
	ZE	W3, W0
; mask end address is: 6 (W3)
	LSR	W0, #1, W0
; mask start address is: 6 (W3)
	MOV.B	W0, W3
;One-Wire LCD.c,39 :: 		for(i = 0; i < 7; i++) {    // send all 7 bits
	INC.B	W2
;One-Wire LCD.c,54 :: 		}
; mask end address is: 6 (W3)
; i end address is: 4 (W2)
	GOTO	L_Send_Byte4
L_Send_Byte5:
;One-Wire LCD.c,60 :: 		One_Wire = 0;        // send 8th bit, lo pulse = 14x15 = 210uS
	BCLR	LATB0_bit, BitPos(LATB0_bit+0)
;One-Wire LCD.c,62 :: 		Delay_us(210);
	MOV	#140, W7
L_Send_Byte9:
	DEC	W7
	BRA NZ	L_Send_Byte9
;One-Wire LCD.c,63 :: 		One_Wire = 1;        // and hi recovery 20x15 = 300 uS
	BSET	LATB0_bit, BitPos(LATB0_bit+0)
;One-Wire LCD.c,65 :: 		Delay_us(300);
	MOV	#200, W7
L_Send_Byte11:
	DEC	W7
	BRA NZ	L_Send_Byte11
;One-Wire LCD.c,66 :: 		}
L_end_Send_Byte:
	RETURN
; end of _Send_Byte

_Write_Nibbles:
	LNK	#2

;One-Wire LCD.c,68 :: 		void Write_Nibbles(char rs, char out_char) {
;One-Wire LCD.c,71 :: 		data2Send = out_char & 0xF0;
	PUSH	W11
	MOV.B	#240, W1
	ADD	W14, #0, W0
	AND.B	W11, W1, [W0]
;One-Wire LCD.c,73 :: 		data2Send.F3 = 1;
	ADD	W14, #0, W0
	BSET.B	[W0], #3
;One-Wire LCD.c,74 :: 		Send_Byte(rs,data2Send);
	PUSH	W11
	MOV.B	[W14+0], W11
	CALL	_Send_Byte
;One-Wire LCD.c,75 :: 		data2Send.F3 = 0;
	ADD	W14, #0, W0
	BCLR.B	[W0], #3
;One-Wire LCD.c,76 :: 		Send_Byte(rs,data2Send);
	MOV.B	[W14+0], W11
	CALL	_Send_Byte
	POP	W11
;One-Wire LCD.c,78 :: 		data2Send = out_char & 0x0F;
	ADD	W14, #0, W0
	AND.B	W11, #15, [W0]
;One-Wire LCD.c,79 :: 		data2Send <<= 4;
	ADD	W14, #0, W0
	ZE	[W0], W0
	SL	W0, #4, W0
	MOV.B	W0, [W14+0]
;One-Wire LCD.c,80 :: 		data2Send.F3 = 1;
	ADD	W14, #0, W0
	BSET.B	[W0], #3
;One-Wire LCD.c,81 :: 		Send_Byte(rs,data2Send);
	MOV.B	[W14+0], W11
	CALL	_Send_Byte
;One-Wire LCD.c,82 :: 		data2Send.F3 = 0;
	ADD	W14, #0, W0
	BCLR.B	[W0], #3
;One-Wire LCD.c,83 :: 		Send_Byte(rs,data2Send);
	MOV.B	[W14+0], W11
	CALL	_Send_Byte
;One-Wire LCD.c,84 :: 		}
L_end_Write_Nibbles:
	POP	W11
	ULNK
	RETURN
; end of _Write_Nibbles

_Write_Nibble:
	LNK	#2

;One-Wire LCD.c,86 :: 		void Write_Nibble(char out_char) {
;One-Wire LCD.c,87 :: 		char data2Send, rs = 0;
	PUSH	W10
	PUSH	W11
; rs start address is: 8 (W4)
	CLR	W4
;One-Wire LCD.c,89 :: 		data2Send = out_char & 0xF0;
	MOV.B	#240, W1
	ADD	W14, #0, W0
	AND.B	W10, W1, [W0]
;One-Wire LCD.c,91 :: 		data2Send.F3 = 1;
	ADD	W14, #0, W0
	BSET.B	[W0], #3
;One-Wire LCD.c,92 :: 		Send_Byte(rs,data2Send);
	MOV.B	[W14+0], W11
	MOV.B	W4, W10
	CALL	_Send_Byte
;One-Wire LCD.c,93 :: 		data2Send.F3 = 0;
	ADD	W14, #0, W0
	BCLR.B	[W0], #3
;One-Wire LCD.c,94 :: 		Send_Byte(rs,data2Send);
	MOV.B	[W14+0], W11
	MOV.B	W4, W10
; rs end address is: 8 (W4)
	CALL	_Send_Byte
;One-Wire LCD.c,95 :: 		}
L_end_Write_Nibble:
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _Write_Nibble

_One_Wire_LCD_Cmd:

;One-Wire LCD.c,97 :: 		void One_Wire_LCD_Cmd(char out_char) {
;One-Wire LCD.c,98 :: 		char rs = 0;
	PUSH	W10
	PUSH	W11
; rs start address is: 0 (W0)
	CLR	W0
;One-Wire LCD.c,100 :: 		Write_Nibbles(rs,out_char);
	MOV.B	W10, W11
	MOV.B	W0, W10
; rs end address is: 0 (W0)
	CALL	_Write_Nibbles
;One-Wire LCD.c,101 :: 		Delay_ms(5);
	MOV	#3333, W7
L_One_Wire_LCD_Cmd13:
	DEC	W7
	BRA NZ	L_One_Wire_LCD_Cmd13
	NOP
;One-Wire LCD.c,102 :: 		}
L_end_One_Wire_LCD_Cmd:
	POP	W11
	POP	W10
	RETURN
; end of _One_Wire_LCD_Cmd

_One_Wire_LCD_Chr:

;One-Wire LCD.c,104 :: 		void One_Wire_LCD_Chr(char row, char col, char out_char) {
;One-Wire LCD.c,105 :: 		char rs = 1;
	PUSH	W10
	PUSH	W11
; rs start address is: 8 (W4)
	MOV.B	#1, W4
;One-Wire LCD.c,107 :: 		switch(row){
	GOTO	L_One_Wire_LCD_Chr15
;One-Wire LCD.c,108 :: 		case 1:
L_One_Wire_LCD_Chr17:
;One-Wire LCD.c,109 :: 		One_Wire_LCD_Cmd(0x80 + col-1);
	MOV	#128, W1
	ZE	W11, W0
	ADD	W1, W0, W0
	DEC	W0
	MOV.B	W0, W10
	CALL	_One_Wire_LCD_Cmd
;One-Wire LCD.c,110 :: 		break;
	GOTO	L_One_Wire_LCD_Chr16
;One-Wire LCD.c,111 :: 		case 2:
L_One_Wire_LCD_Chr18:
;One-Wire LCD.c,112 :: 		One_Wire_LCD_Cmd(0xC0 + col-1);
	MOV	#192, W1
	ZE	W11, W0
	ADD	W1, W0, W0
	DEC	W0
	MOV.B	W0, W10
	CALL	_One_Wire_LCD_Cmd
;One-Wire LCD.c,113 :: 		break;
	GOTO	L_One_Wire_LCD_Chr16
;One-Wire LCD.c,114 :: 		case 3:
L_One_Wire_LCD_Chr19:
;One-Wire LCD.c,115 :: 		One_Wire_LCD_Cmd(0x94 + col-1);
	MOV	#148, W1
	ZE	W11, W0
	ADD	W1, W0, W0
	DEC	W0
	MOV.B	W0, W10
	CALL	_One_Wire_LCD_Cmd
;One-Wire LCD.c,116 :: 		break;
	GOTO	L_One_Wire_LCD_Chr16
;One-Wire LCD.c,117 :: 		case 4:
L_One_Wire_LCD_Chr20:
;One-Wire LCD.c,118 :: 		One_Wire_LCD_Cmd(0xD4 + col-1);
	MOV	#212, W1
	ZE	W11, W0
	ADD	W1, W0, W0
	DEC	W0
	MOV.B	W0, W10
	CALL	_One_Wire_LCD_Cmd
;One-Wire LCD.c,119 :: 		break;
	GOTO	L_One_Wire_LCD_Chr16
;One-Wire LCD.c,120 :: 		}
L_One_Wire_LCD_Chr15:
	CP.B	W10, #1
	BRA NZ	L__One_Wire_LCD_Chr50
	GOTO	L_One_Wire_LCD_Chr17
L__One_Wire_LCD_Chr50:
	CP.B	W10, #2
	BRA NZ	L__One_Wire_LCD_Chr51
	GOTO	L_One_Wire_LCD_Chr18
L__One_Wire_LCD_Chr51:
	CP.B	W10, #3
	BRA NZ	L__One_Wire_LCD_Chr52
	GOTO	L_One_Wire_LCD_Chr19
L__One_Wire_LCD_Chr52:
	CP.B	W10, #4
	BRA NZ	L__One_Wire_LCD_Chr53
	GOTO	L_One_Wire_LCD_Chr20
L__One_Wire_LCD_Chr53:
L_One_Wire_LCD_Chr16:
;One-Wire LCD.c,122 :: 		Write_Nibbles(rs,out_char);
	MOV.B	W12, W11
	MOV.B	W4, W10
; rs end address is: 8 (W4)
	CALL	_Write_Nibbles
;One-Wire LCD.c,123 :: 		}
L_end_One_Wire_LCD_Chr:
	POP	W11
	POP	W10
	RETURN
; end of _One_Wire_LCD_Chr

_One_Wire_LCD_Chr_Cp:

;One-Wire LCD.c,125 :: 		void One_Wire_LCD_Chr_Cp(char out_char) {
;One-Wire LCD.c,126 :: 		char rs = 1;
	PUSH	W10
	PUSH	W11
; rs start address is: 0 (W0)
	MOV.B	#1, W0
;One-Wire LCD.c,128 :: 		Write_Nibbles(rs,out_char);
	MOV.B	W10, W11
	MOV.B	W0, W10
; rs end address is: 0 (W0)
	CALL	_Write_Nibbles
;One-Wire LCD.c,129 :: 		}
L_end_One_Wire_LCD_Chr_Cp:
	POP	W11
	POP	W10
	RETURN
; end of _One_Wire_LCD_Chr_Cp

_One_Wire_LCD_Out:

;One-Wire LCD.c,131 :: 		void One_Wire_LCD_Out(char row, char col, char *text) {
;One-Wire LCD.c,132 :: 		while(*text)
L_One_Wire_LCD_Out21:
	CP0.B	[W12]
	BRA NZ	L__One_Wire_LCD_Out56
	GOTO	L_One_Wire_LCD_Out22
L__One_Wire_LCD_Out56:
;One-Wire LCD.c,133 :: 		One_Wire_LCD_Chr(row,col++,*text++);
	PUSH	W12
	PUSH	W11
	MOV.B	[W12], W12
	CALL	_One_Wire_LCD_Chr
	POP	W11
	POP	W12
	ADD.B	W11, #1, W0
	MOV.B	W0, W11
	ADD	W12, #1, W0
	MOV	W0, W12
	GOTO	L_One_Wire_LCD_Out21
L_One_Wire_LCD_Out22:
;One-Wire LCD.c,134 :: 		}
L_end_One_Wire_LCD_Out:
	RETURN
; end of _One_Wire_LCD_Out

_One_Wire_LCD_Out_Cp:

;One-Wire LCD.c,136 :: 		void One_Wire_LCD_Out_Cp(char *text) {
;One-Wire LCD.c,137 :: 		while(*text)
L_One_Wire_LCD_Out_Cp23:
	CP0.B	[W10]
	BRA NZ	L__One_Wire_LCD_Out_Cp58
	GOTO	L_One_Wire_LCD_Out_Cp24
L__One_Wire_LCD_Out_Cp58:
;One-Wire LCD.c,138 :: 		One_Wire_LCD_Chr_Cp(*text++);
	PUSH	W10
	MOV.B	[W10], W10
	CALL	_One_Wire_LCD_Chr_Cp
	POP	W10
	ADD	W10, #1, W0
	MOV	W0, W10
	GOTO	L_One_Wire_LCD_Out_Cp23
L_One_Wire_LCD_Out_Cp24:
;One-Wire LCD.c,139 :: 		}
L_end_One_Wire_LCD_Out_Cp:
	RETURN
; end of _One_Wire_LCD_Out_Cp

_One_Wire_LCD_Init:

;One-Wire LCD.c,141 :: 		void One_Wire_LCD_Init() {
;One-Wire LCD.c,142 :: 		Delay_ms(150);
	PUSH	W10
	MOV	#2, W8
	MOV	#34463, W7
L_One_Wire_LCD_Init25:
	DEC	W7
	BRA NZ	L_One_Wire_LCD_Init25
	DEC	W8
	BRA NZ	L_One_Wire_LCD_Init25
	NOP
;One-Wire LCD.c,143 :: 		Write_Nibble(0x30);
	MOV.B	#48, W10
	CALL	_Write_Nibble
;One-Wire LCD.c,144 :: 		Delay_ms(30);
	MOV	#20000, W7
L_One_Wire_LCD_Init27:
	DEC	W7
	BRA NZ	L_One_Wire_LCD_Init27
;One-Wire LCD.c,145 :: 		Write_Nibble(0x30);
	MOV.B	#48, W10
	CALL	_Write_Nibble
;One-Wire LCD.c,146 :: 		Delay_ms(30);
	MOV	#20000, W7
L_One_Wire_LCD_Init29:
	DEC	W7
	BRA NZ	L_One_Wire_LCD_Init29
;One-Wire LCD.c,147 :: 		Write_Nibble(0x30);
	MOV.B	#48, W10
	CALL	_Write_Nibble
;One-Wire LCD.c,148 :: 		Delay_ms(30);
	MOV	#20000, W7
L_One_Wire_LCD_Init31:
	DEC	W7
	BRA NZ	L_One_Wire_LCD_Init31
;One-Wire LCD.c,149 :: 		Write_Nibble(0x20);
	MOV.B	#32, W10
	CALL	_Write_Nibble
;One-Wire LCD.c,150 :: 		Delay_ms(20);
	MOV	#13333, W7
L_One_Wire_LCD_Init33:
	DEC	W7
	BRA NZ	L_One_Wire_LCD_Init33
	NOP
;One-Wire LCD.c,151 :: 		One_Wire_LCD_Cmd(0x28);
	MOV.B	#40, W10
	CALL	_One_Wire_LCD_Cmd
;One-Wire LCD.c,152 :: 		Delay_ms(10);
	MOV	#6666, W7
L_One_Wire_LCD_Init35:
	DEC	W7
	BRA NZ	L_One_Wire_LCD_Init35
	NOP
	NOP
;One-Wire LCD.c,153 :: 		One_Wire_LCD_Cmd(0x06);
	MOV.B	#6, W10
	CALL	_One_Wire_LCD_Cmd
;One-Wire LCD.c,154 :: 		Delay_ms(10);
	MOV	#6666, W7
L_One_Wire_LCD_Init37:
	DEC	W7
	BRA NZ	L_One_Wire_LCD_Init37
	NOP
	NOP
;One-Wire LCD.c,155 :: 		}
L_end_One_Wire_LCD_Init:
	POP	W10
	RETURN
; end of _One_Wire_LCD_Init

_main:
	MOV	#2048, W15
	MOV	#6142, W0
	MOV	WREG, 32
	MOV	#1, W0
	MOV	WREG, 52
	MOV	#4, W0
	IOR	68

;One-Wire LCD.c,157 :: 		void main() {
;One-Wire LCD.c,159 :: 		TRISB = 0x0000;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	CLR	TRISB
;One-Wire LCD.c,161 :: 		One_Wire = 1;
	BSET	LATB0_bit, BitPos(LATB0_bit+0)
;One-Wire LCD.c,163 :: 		One_Wire_LCD_Init();
	CALL	_One_Wire_LCD_Init
;One-Wire LCD.c,164 :: 		One_Wire_LCD_Cmd(_LCD_CLEAR);
	MOV.B	#1, W10
	CALL	_One_Wire_LCD_Cmd
;One-Wire LCD.c,165 :: 		One_Wire_LCD_Cmd(_LCD_CURSOR_OFF);
	MOV.B	#12, W10
	CALL	_One_Wire_LCD_Cmd
;One-Wire LCD.c,167 :: 		One_Wire_LCD_Out(1,1,"One-Wire");
	MOV	#lo_addr(?lstr1_One_45Wire_32LCD), W12
	MOV.B	#1, W11
	MOV.B	#1, W10
	CALL	_One_Wire_LCD_Out
;One-Wire LCD.c,168 :: 		One_Wire_LCD_Out(2,1,"Serial LCD");
	MOV	#lo_addr(?lstr2_One_45Wire_32LCD), W12
	MOV.B	#1, W11
	MOV.B	#2, W10
	CALL	_One_Wire_LCD_Out
;One-Wire LCD.c,169 :: 		One_Wire_LCD_Out(3,1,"20x4");
	MOV	#lo_addr(?lstr3_One_45Wire_32LCD), W12
	MOV.B	#1, W11
	MOV.B	#3, W10
	CALL	_One_Wire_LCD_Out
;One-Wire LCD.c,170 :: 		One_Wire_LCD_Out(4,1,"Using 74HC595");
	MOV	#lo_addr(?lstr4_One_45Wire_32LCD), W12
	MOV.B	#1, W11
	MOV.B	#4, W10
	CALL	_One_Wire_LCD_Out
;One-Wire LCD.c,172 :: 		while(1){
L_main39:
;One-Wire LCD.c,174 :: 		}
	GOTO	L_main39
;One-Wire LCD.c,175 :: 		}
L_end_main:
	POP	W12
	POP	W11
	POP	W10
L__main_end_loop:
	BRA	L__main_end_loop
; end of _main
